#ifndef HCHAIN_H
#define HCHAIN_H
// -----------------------------------------------------------------------------

class hash_chain
{
private:
    int** _valtab;              ///< Tablica wartosci
    int* _sizetab;              ///< Tablica rozmiarow poszczegolnych list
    int _size;                  ///< Ilosc list
    int (*_hash)(int __val);    ///< Wskaznik do funkcji haszujacej

    /// \brief Zmienia rozmiar listy o podanym indeksie
    ///
    /// \param __listindex - indeks listy ktorej rozmiar chcemy zmienic
    /// \param __increase - okresla jak zmienic rozmiar tablicy
    /// \li jezeli true - zwieksza rozmiar o jeden
    /// \li jezeli false - zmniejsza rozmiar o jeden
    /// \returns true w przypadku wykonania wszystkich operacji poprawnie, false w przeciwnym wypadku
    bool changeListSize(int __listindex, bool __increase = true);

    /// \brief Wyszukuje wartosc na podanej liscie
    ///
    /// \param __listindex - indeks listy na ktorej szukamy
    /// \param __val - wartosc ktora chcemy znalezc
    /// \returns index wartosci jezeli znaleziona, -1 jezeli taka wartosc nie istnieje
    int findOnTheList(int __listindex, int __val);

public:

    /// \brief Konstrutor
    ///
    /// \param __size - rozmiar tablicy
    /// \param __hashfunc - wskaznik na funkcje haszujaca
    hash_chain(int __size, int (*__hashfunc)(int));

    /// \brief Destruktor
    ~hash_chain(void);

    /// \brief Wstawia wartosc do  tablicy
    ///
    /// \param __val - wartosc ktora wstawiamy
    /// \returns false w przypadku bledu, inaczej true
    bool insert(int __val);

    /// \brief Usuwa wartosc z tablicy
    ///
    /// \param __val - wartosc ktora chcemy usunac
    /// \returns true w przypadku sukcesu, w przypadku bledu false
    bool remove(int __val);

    /// \brief Sprawdza czy dana wartosc istnieje w tablicy
    ///
    /// \param __val - wartosc ktorej istnienie chcemy sprawdzic
    /// \returns true jezeli dana wartosc istnieje, false w przeciwnym razie
    bool exists(int __val);

    /// \brief Wyswietla wartosci w tablicy z podzialem na listy
    void printValues(void);

    /// \brief Wyswietla informacje dotyczace tablicy
    void printInfo(void);
};
// -----------------------------------------------------------------------------

#endif
