#include <iostream>
using namespace std;
// -----------------------------------------------------------------------------

#include "hopen.h"
// -----------------------------------------------------------------------------

hash_open::hash_open(int __size, int (*__hashfunc)(int, int))
{
    _valtab = NULL;
    _ststab = NULL;
    _size = 0;
    _hash = NULL;

    if(__size <= 0)
        return;
    if(__hashfunc == NULL)
        return;

    _valtab = new int[__size];
    _ststab = new int[__size];
    _size = __size;
    _hash = __hashfunc;

    for(int i=0;i<_size;++i)
        _ststab[i] = STS_FREE;
}
// -----------------------------------------------------------------------------

hash_open::~hash_open(void)
{
    delete [] _valtab;
    delete [] _ststab;

    // aby zabezpieczyc przed jawnym wywolaniem destruktora
    _valtab = NULL;
    _ststab = NULL;
    _size = 0;
}
// -----------------------------------------------------------------------------

int hash_open::count(void)
{
    int sum = 0;
    for(int i=0;i<_size;++i)
    {
        if(_ststab[i] == STS_USED)
            sum++;
    }
    return sum;
}
// -----------------------------------------------------------------------------

bool hash_open::insert(int __val)
{
    int i = 0;
    while(i < _size)
    {
        int index = _hash(__val, i);
        if(_ststab[index] == STS_FREE)
        {
            _ststab[index] = STS_USED;
            _valtab[index] = __val;
            return true;
        }
        ++i;
    }
    return false;
}
// -----------------------------------------------------------------------------

bool hash_open::remove(int __val)
{
    int i = 0;
    while(i < _size)
    {
        int index = _hash(__val, i);
        if(_ststab[index] == STS_FREE)
            return false;
        if((_ststab[index] == STS_USED) && (_valtab[index] == __val))
            _ststab[index] = STS_FREE;
        ++i;
    }
    return false;
}
// ---------------------------------------------------------------------------

int hash_open::search(int __val)
{
    int i = 0;
    while(i < _size)
    {
        int index = _hash(__val, i);
        if(_ststab[index] == STS_FREE)      // jezeli natrafiamy na free to mamy pewnosc ze dalej nic nie ma
            return -1;
        if(((_ststab[index] == STS_USED)) && (_valtab[index] == __val))
            return index;
        ++i;
    }
    return -1;
}
// ---------------------------------------------------------------------------

bool hash_open::exists(int __val)
{
    return search(__val) != -1;
}
// ---------------------------------------------------------------------------

void hash_open::printValues(void)
{
    for(int i=0;i<_size;++i)
    {
        if(_ststab[i] == STS_FREE)
            cout << "FREE, ";
        else
            cout << _valtab[i] << ", ";
    }
    cout << endl;
}
// ---------------------------------------------------------------------------

void hash_open::printInfo(void)
{
    cout << "Rozmiar tablicy: " << _size << endl;
    cout << "Ilosc elementow: " << count() << endl;
}
// ---------------------------------------------------------------------------
