#ifndef HOPEN_H
#define HOPEN_H
// -----------------------------------------------------------------------------

#define STS_FREE 0
#define STS_USED 1
// -----------------------------------------------------------------------------

class hash_open
{
private:
    int* _valtab;                       ///< Tablica wartosci
    int* _ststab;                       ///< Tablica stanow pol
    int _size;                          ///< Rozmiar tablicy
    int (*_hash)(int __val, int __i);   ///< Wskaznik do funkcji haszujacej

    /// \brief Zwraca liczbe wszystkich elementow w tablicy
    ///
    /// \returns liczbe wszystkich elementow w tablicy
    int count(void);

public:

    /// \brief Konstrutor
    ///
    /// \param __size - rozmiar tablicy
    /// \param __hashfunc - wskaznik na funkcje haszujaca
    hash_open(int __size, int (*__hashfunc)(int, int));

    /// \brief Destruktor
    ~hash_open(void);

    /// \brief Wstawia wartosc do  tablicy
    ///
    /// \param __val - wartosc ktora wstawiamy
    /// \returns false w przypadku przepelnienia tablicy, inaczej true
    bool insert(int __val);

    /// \brief Usuwa wartosc z tablicy
    ///
    /// \param __val - wartosc ktora chcemy usunac
    /// \returns true w przypadku sukcesu, w przypadku bledu false
    bool remove(int __val);

    /// \brief Sprawdza czy dana wartosc istnieje w tablicy
    ///
    /// \param __val - wartosc ktorej istnienie chcemy sprawdzic
    /// \returns true jezeli dana wartosc istnieje, false w przeciwnym razie
    bool exists(int __val);

    /// \brief Sprawdza czy dana wartosc istnieje w tablicy
    ///
    /// \param __val - wartosc ktorej istnienie chcemy sprawdzic
    /// \returns index wartosci jezeli dana wartosc istnieje, -1 w przeciwnym razie
    int search(int __val);

    /// \brief Wyswietla wartosci w tablicy z podzialem na listy
    void printValues(void);

    /// \brief Wyswietla informacje dotyczace tablicy
    void printInfo(void);
};
// -----------------------------------------------------------------------------

#endif
